#ifndef __PWM_H
#define __PWM_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <sys/stat.h>

#include "inc-gen/data_dictionary.h"
#include "inc/libmaestro.h"

// macros
// 	6072 is the value for 0, max. value to motor is currently 7572
//	from AF3 you get a max. speed value in mm/s : 1471
//	Hence, add the constant 6072 and map values -1471-1471 to -1500-1500
#define PWM_ADJUST_VALUE(x) (6072 + 1500 * x /1471)

// types
typedef unsigned char PWM_CHANNEL_T;

// constants
extern const int PWM_SLEEP_TIME;
extern const char* PWM_DEVICE_NAME;
extern const size_t PWM_MAX_NO_CHANNELS;

// worker
void* pwm_worker(void* pt_args);

// init, term
void pwm_init(PWM_CHANNEL_T channel);
void pwm_term(PWM_CHANNEL_T channel);

// writers
void pwm_write(PWM_CHANNEL_T channel, GEN_TYPE_int value);
void pwm_set_noval(PWM_CHANNEL_T channel);

#endif // __PWM_H
