#ifndef __LIBCANSOCKET_H
#define __LIBCANSOCKET_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <net/if.h>
#include <sys/ioctl.h>

#include <linux/can.h>
#include <linux/can/raw.h>

#define SR_ERR -1

struct can_socket {
    int s;
    struct sockaddr_can addr;
    struct ifreq ifr;
};

/**
 * Opens a can socket on the given interface
 */
struct can_socket* can_socket_open(const char *if_name);

/**
 * Closes a given socket
 */
void can_socket_close(struct can_socket* sock);

/**
 * Sends a can frame on the specified socket
 */
ssize_t can_socket_send(struct can_socket* sock, struct can_frame* frame);

/**
 * 
 */
ssize_t can_socket_receive(struct can_socket* sock, struct can_frame* frame);

#endif // __LIBCANSOCKET_H
