/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.compose;

import static org.conqat.lib.commons.reflect.ReflectionUtils.isInstanceOfAny;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.af3.platform.compose.PlatformArchitectureElementCompositorBase;
import org.fortiss.af3.platform.model.IPlatformArchitectureElement;
import org.fortiss.af3.platform.raspberry.model.ActuatorPWM;
import org.fortiss.af3.platform.raspberry.model.CanConnector;
import org.fortiss.af3.platform.raspberry.model.RaspberryPi;
import org.fortiss.af3.platform.raspberry.model.brick.AccelerationXSensor;
import org.fortiss.af3.platform.raspberry.model.brick.AccelerationYSensor;
import org.fortiss.af3.platform.raspberry.model.brick.AccelerationZSensor;
import org.fortiss.af3.platform.raspberry.model.brick.AngularVelocityXSensor;
import org.fortiss.af3.platform.raspberry.model.brick.AngularVelocityYSensor;
import org.fortiss.af3.platform.raspberry.model.brick.AngularVelocityZSensor;
import org.fortiss.af3.platform.raspberry.model.brick.LaserRangeSensor;
import org.fortiss.af3.platform.raspberry.model.brick.UltraSonicSensor;
import org.fortiss.af3.platform.raspberry.model.gamepad.Button1;
import org.fortiss.af3.platform.raspberry.model.gamepad.Button2;
import org.fortiss.af3.platform.raspberry.model.gamepad.Button3;
import org.fortiss.af3.platform.raspberry.model.gamepad.Button4;
import org.fortiss.af3.platform.raspberry.model.gamepad.ButtonL1;
import org.fortiss.af3.platform.raspberry.model.gamepad.ButtonL2;
import org.fortiss.af3.platform.raspberry.model.gamepad.ButtonR1;
import org.fortiss.af3.platform.raspberry.model.gamepad.ButtonR2;
import org.fortiss.af3.platform.raspberry.model.gamepad.Left_StickX_Position;
import org.fortiss.af3.platform.raspberry.model.gamepad.Left_StickY_Position;
import org.fortiss.af3.platform.raspberry.model.gamepad.Right_StickX_Position;
import org.fortiss.af3.platform.raspberry.model.gamepad.Right_StickY_Position;
import org.fortiss.tooling.kernel.extension.data.IElementCompositionContext;
import org.fortiss.tooling.kernel.extension.data.Prototype;

/**
 * 
 * @author eder
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash:
 */
public class RaspberryPiCompositor extends
		PlatformArchitectureElementCompositorBase<IPlatformArchitectureElement> {

	/** {@inheritDoc} */
	@Override
	public boolean canComposePrototype(Prototype prototype) {
		return super.canComposePrototype(prototype);
	}

	/** {@inheritDoc} */
	@Override
	public boolean canCompose(IPlatformArchitectureElement container, EObject contained,
			IElementCompositionContext context) {
		return super.canCompose(container, contained, context);
	}

	/** {@inheritDoc} */
	@Override
	protected boolean isCorrectElementClass(IPlatformArchitectureElement container,
			EObject contained) {
		final boolean instanceOfAny2 =
				isInstanceOfAny(contained, CanConnector.class, ActuatorPWM.class, Button1.class,
						Button2.class, Button3.class, Button4.class, ButtonL1.class,
						ButtonL2.class, ButtonR1.class, ButtonR2.class, Left_StickX_Position.class,
						Left_StickY_Position.class, Right_StickX_Position.class,
						Right_StickY_Position.class, UltraSonicSensor.class,
						LaserRangeSensor.class, AccelerationXSensor.class,
						AccelerationYSensor.class, AccelerationZSensor.class,
						AngularVelocityXSensor.class, AngularVelocityYSensor.class,
						AngularVelocityZSensor.class);
		if(container != null) {
			final boolean instanceOfAny = isInstanceOfAny(container, RaspberryPi.class);
			return instanceOfAny && instanceOfAny2;
		}
		return instanceOfAny2;
	}

}
